(function () {
    "use strict";

    angular.module('core').controller('romaneioDetailController', controller);
    controller.$inject = ['$scope', '$timeout', 'codigoBarraService','$state', '$stateParams', 'romaneioService', '$q', 'lookupService', '$alert'];

    function controller($scope, $timeout, codigoBarraService, $state, $stateParams, romaneioService) {
        $scope.initializeLayout('Romaneio de Mercadoria');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false
        };
        $scope.popups = {
            item: {
                ativo: false,
                carregando: false,
                filtro: { codigoProdutoOuBarras: null, codigoProduto: null },
                prepareItem: function () {
                    romaneioService
                        .prepare({ romaneio: $scope.state.item })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                    $scope.popups.item.filtro.codigoProduto = null;
                                    $scope.popups.item.filtro.codigoProdutoOuBarras = null;
                                }
                                $scope.popups.item.ativo = false;
                            },
                            function (_error) {
                                $scope.popups.item.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareFiltroProduto: function () {
                    /* Após preparar o item pelo código de barras, descobre o 
                     código do produto bipado para filtrar a edição do item
                     alimentando a propriedade codigoProduto. */
                    
                    var args = { codigoBarra: $scope.popups.item.filtro.codigoProdutoOuBarras };

                    codigoBarraService
                        .get(args)
                        .then(
                            function (response) {  
                                if (response.Status >= 0) {
                                    if (response.Data)
                                        $scope.popups.item.filtro.codigoProduto = response.Data.SKU.Produto.Codigo;
                                    else
                                        $scope.popups.item.filtro.codigoProduto = $scope.popups.item.filtro.codigoProdutoOuBarras;
                                }
                                $scope.popups.item.filtro.codigoProdutoOuBarras = null;
                            });
                }
            }
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {

                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            romaneioService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.prepareNewItem = function () {

            if (!$scope.popups.item.filtro.codigoProdutoOuBarras)
                return;

            $scope.state.carregando = true;
            var args = {
                codigo: $scope.popups.item.filtro.codigoProdutoOuBarras,
                romaneio: $scope.state.item
            };
            romaneioService
                .prepareNewItem(args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data.Romaneio;
                            $scope.popups.item.prepareFiltroProduto();
                            $scope.popups.item.ativo = true;
                        }
                        $scope.state.carregando = false;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };

        $scope.setEncerrada = function () {

            romaneioService.SetEncerrada($scope.state.item).then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.popups.item.carregando = false;
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.refresh();
                    }
                }
            );
        };
        $scope.save = function () {
            $scope.popups.item.carregando = true;
            romaneioService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.popups.item.carregando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.popups.item.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        }

        /*Inicializa funções*/
        $scope.initialize();

    }

})();